<?php
require_once("/home/spool/edugain-urn/Web/config.php");
require_once($realpath."/siLeDAP/LdapManager.php");
require_once($realpath."/siLeDAP/LdapConf.php");
require_once($realpath."/siLeDAP/xml2Array.php");

function echoURNDescription($urn) {
	$res='';
	$res.="<urn value='".$urn->getSingleAttribute("urnRegValue")."'>";
	if ($urn->hasAttribute("urnRegValueDescription")) {
		$res.="<descriptions>";
		foreach ($urn->getAttribute("urnRegValueDescription")->getArrayValues() as $descattr) {
			$res.="  <description value='".$descattr['value']."' />";
		}
		$res.="</descriptions>";
	}
	if ($urn->hasAttribute("urnRegValuePresentation")) {
		$res.="<presentations>";
		$attr=$urn->getAttribute("urnRegValuePresentation");
		foreach ($attr->getArrayValues() as $repattr) {
			if (array_key_exists("lang",$repattr)) {
				$res.="  <presentation value='".$repattr['value']."' lang='".$repattr['lang']."' />";
			}
			else {
				$res.="  <presentation value='".$repattr['value']."' />";
			}
		}
		$res.="</presentations>";
	}
	$res.="</urn>";
	
	return $res;
}

function getURN($lm,$urnvalue) {
	GLOBAL $URN_BASE;
	
	$resState=false;
	$urn=getURNEntry($lm,$urnvalue);
	$objs=$urn->getObjectClassList()->getValues();
	if (in_array("urnRegDelegationStr",$objs)||in_array("urnRegDelegation",$objs)) {
		$urnvalue=$urn->getSingleAttribute("urnRegValue");
		$wsEP=$urn->getSingleAttribute("urnRegHttpURIHuman");
		$resState=getDelegatedURN($urnvalue,$wsEP);
	}
	else if (in_array("urnRegDescriptionStr",$objs)||in_array("urnRegDescription",$objs)) {
		$resState=echoURNDescription($urn);
	}
	return $resState;
}

function getURNEntry($lm,$urnvalue) {
	GLOBAL $URN_BASE;

	$filter="(urnRegValue=".$urnvalue.")";
	$entries=$lm->search($URN_BASE,$filter);
	if (count($entries)==1) {
		$urn=$entries[0];
		return $urn;
	}
	return "";
}

function getDelegatedURNArray($urnvalue,$wsEP) {
	$params="?oper=geturn&urnvalue=".base64_encode($urnvalue);
	
	$content='';
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $wsEP.$params);
    curl_setopt($ch, CURLOPT_HEADER, 0); 
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $content);
    ob_start();
    curl_exec ($ch);
    curl_close ($ch);
    $res = ob_get_contents();
    ob_end_clean();
    $objXML = new xml2Array();
    $arrayXML = $objXML->parse($res);
    
    $urnarray=$arrayXML[0]['children'][0];

	return $urnarray;	
}

function getDelegatedURN($urnvalue,$wsEP) {
	$urnarray=getDelegatedURNArray($urnvalue,$wsEP);

	return processUrnArray($urnarray,$wsEP);
}

function processUrnArray($urnarray,$wsEP) {
	echo "<urn value='".$urnarray['attrs']['VALUE']."' delegated='".$wsEP."'>";
	for ($i=0; $i<count($urnarray['children']); $i++) {
		if (strcmp($urnarray['children'][$i]['name'],"DESCRIPTIONS")==0) {
			echo "<descriptions>";
			$descs=$urnarray['children'][$i];
			for ($j=0; $j<count($descs['children']); $j++) {
				echo "<description value='".$descs['children'][$j]['attrs']['VALUE']."' />";
			}
			echo "</descriptions>";
		}
		else if (strcmp($urnarray['children'][$i]['name'],"PRESENTATIONS")==0) {
			echo "<presentations>";
			$precs=$urnarray['children'][$i];
			for ($j=0; $j<count($precs['children']); $j++) {
				if (array_key_exists('LANG',$precs['children'][$j]['attrs'])) {
					echo "<presentation value='".$precs['children'][$j]['attrs']['VALUE']."' lang='".$precs['children'][$j]['attrs']['LANG']."' />";
				}
				else {
					echo "<presentation value='".$precs['children'][$j]['attrs']['VALUE']."' />";
				}
			}
			echo "</presentations>";
		}
	}
	echo "</urn>";
	
	return true;
}

function getDelegatedSubURNs($urnvalue,$wsEP) {
	$arrayXML=getDelegatedSubURNsArray($urnvalue,$wsEP);
    
	return processDelegatedSubURNs($arrayXML,$wsEP);
}

function getDelegatedSubURNsArray($urnvalue,$wsEP) {
	$params="?oper=getsuburns&urnvalue=".base64_encode($urnvalue);
	
	$content='';
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $wsEP.$params);
    curl_setopt($ch, CURLOPT_HEADER, 0); 
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $content);
    ob_start();
    curl_exec ($ch);
    curl_close ($ch);
    $res = ob_get_contents();
    ob_end_clean();
    $objXML = new xml2Array();
    $arrayXML = $objXML->parse($res);
    
    return $arrayXML;
}

function processDelegatedSubURNs($arrayXML,$wsEP) {
	echo "<urns>";
	if (strcmp($arrayXML[0]['children'][0]['name'],"URNS")==0) {
		$urns=$arrayXML[0]['children'][0]['children'];
		for ($i=0; $i<count($urns); $i++) {
		    $urnarray=$arrayXML[0]['children'][0]['children'][$i];
			processUrnArray($urnarray,$wsEP);
		}
	}
	echo "</urns>";
	
	return true;
}

function getSubURNs($lm,$urnvalue) {
	GLOBAL $URN_BASE;
	
	$resState=false;
	
	$filter="(urnRegValue=".$urnvalue.":*)";
	$entries=$lm->search($URN_BASE,$filter,false);
	usort($entries,"sortSubUrns");
	echo "<urns>";
	if (count($entries)>0) {
		$entryMin=$entries[0];
		$min=count(explode(":",$entryMin->getSingleAttribute("urnRegValue")));
		$end=false;
		for ($i=0; $i<count($entries)&&$end==false; $i++) {
			$entry=$entries[$i];
			$tokens=count(explode(":",$entry->getSingleAttribute("urnRegValue")));
			if ($tokens>$min) {
				$end=true;
			}
			else {
				$objs=$entry->getObjectClassList()->getValues();
				if (in_array("urnRegDelegationStr",$objs)||in_array("urnRegDelegation",$objs)) {
					$urnvalue=$entry->getSingleAttribute("urnRegValue");
					$wsEP=$entry->getSingleAttribute("urnRegHttpURIHuman");
					$resState=getDelegatedURN($urnvalue,$wsEP);
				}
				else if (in_array("urnRegDescriptionStr",$objs)||in_array("urnRegDescription",$objs)) {
					$resState=echoURNDescription($entry);
				}
			}
		}
	}
	echo "</urns>";
	
	return $resState;
}

function searchSubURNs($lm,$urn,$search) {
	GLOBAL $URN_BASE;
	
	$resState=true;
	
	$filter="(urnRegValue=".$urn.":*)";
	$entries=$lm->search($URN_BASE,$filter,false,array("objectClass","urnRegValue"));
	usort($entries,"sortSubUrns");
	if (count($entries)>0) {
		$entryMin=$entries[0];
		$min=count(explode(":",$entryMin->getSingleAttribute("urnRegValue")));
		$end=false;
		for ($i=0; $i<count($entries)&&$end==false&&$resState==true; $i++) {
			$entry=$entries[$i];
			$tokens=count(explode(":",$entry->getSingleAttribute("urnRegValue")));
			if ($tokens>$min) {
				$end=true;
			}
			else {
				$objs=$entry->getObjectClassList()->getValues();
				$urnvalue=$entry->getSingleAttribute("urnRegValue");
				if (in_array("urnRegDelegationStr",$objs)||in_array("urnRegDelegation",$objs)) {
					$wsEP=$entry->getSingleAttribute("urnRegHttpURIHuman");
					$resState=searchURNs($lm,$urnvalue,$search,$wsEP);
				}
				else if (in_array("urnRegDescriptionStr",$objs)||in_array("urnRegDescription",$objs)) {
					$resState=searchURNs($lm,$urnvalue,$search);
				}
			}
		}
	}
	
	return $resState;
}

function searchDelegatedSubURNs($lm,$urn,$search,$wsEP) {
	$resState=true;
	
	$arrayXML=getDelegatedSubURNsArray($urn,$wsEP);
	if (strcmp($arrayXML[0]['children'][0]['name'],"URNS")==0) {
		$urns=$arrayXML[0]['children'][0]['children'];
		for ($i=0; $i<count($urns)&&$resState==true; $i++) {
		    $urnarray=$arrayXML[0]['children'][0]['children'][$i];
		    
			$found=false;
		
			$urnvalue=$urnarray['attrs']['VALUE'];
			$found|=stripos($urnvalue,$search)!==false;
		
			for ($i=0; $i<count($urnarray['children']); $i++) {
				if (strcmp($urnarray['children'][$i]['name'],"DESCRIPTIONS")==0) {
					$descs=$urnarray['children'][$i];
					for ($j=0; $j<count($descs['children']); $j++) {
						$found|=stripos($descs['children'][$j]['attrs']['VALUE'],$search)!==false;
					}
				}
			}
			if ($found==true) {
				$resState=processUrnArray($urnarray,$wsEP);
			}
			$resState=searchURNs($lm,$urnvalue,$search,$wsEP);
		}
	}
	
	return $resState;
}

function searchURNs($lm,$urn,$search,$wsEP='') {
	$resState=false;
	
	if (strcmp($wsEP,"")==0) { // It's NOT a delegated URN
		$urnEntry=getURNEntry($lm,$urn);
		if (strcmp($urnEntry,"")!=0) {
			$objs=$urnEntry->getObjectClassList()->getValues();
			$urnvalue=$urnEntry->getSingleAttribute("urnRegValue");
			if (in_array("urnRegDelegationStr",$objs)||in_array("urnRegDelegation",$objs)) { // Anyway, we should check if it's a delegated URN
				$newWsEP=$urnEntry->getSingleAttribute("urnRegHttpURIHuman");
				$resState=searchURNs($lm,$urnvalue,$search,$newWsEP); // Searching again with its end point
			}
			else if (in_array("urnRegDescriptionStr",$objs)||in_array("urnRegDescription",$objs)) { // Actually, it's a description urn
				$urndescs=$urnEntry->getSingleAttribute("urnRegValueDescription");
				$found=false;
				foreach ($urnEntry->getAttribute("urnRegValueDescription")->getArrayValues() as $descattr) {
					$found|=stripos($descattr['value'],$search)!==false;
				}
				$found|=stripos($urnvalue,$search)!==false;
				if ($found==true) {
					$resState=echoURNDescription($urnEntry);
				}
				else {
					$resState=true;
				}
			}
			// Search in sub URNs
			if ($resState==true) {
				$resState=searchSubURNs($lm,$urnvalue,$search);		
			}
		}
	}
	else {
		$urnarray=getDelegatedURNArray($urn,$wsEP);
		$found=false;
		
		$urnvalue=$urnarray['attrs']['VALUE'];
		$found|=stripos($urnvalue,$search)!==false;
		
		for ($i=0; $i<count($urnarray['children']); $i++) {
			if (strcmp($urnarray['children'][$i]['name'],"DESCRIPTIONS")==0) {
				$descs=$urnarray['children'][$i];
				for ($j=0; $j<count($descs['children']); $j++) {
					$found|=stripos($descs['children'][$j]['attrs']['VALUE'],$search)!==false;
				}
			}
		}
		if ($found==true) {
			$resState=processUrnArray($urnarray,$wsEP);
		}
		else {
			$resState=true;
		}
		if ($resState==true) {
			$resState=searchDelegatedSubURNs($lm,$urnvalue,$search,$wsEP);
		}
	}
	
	return $resState;
}

function sortSubUrns($elem1,$elem2) {
	$val1=explode(":",$elem1->getSingleAttribute("urnRegValue"));
	$val2=explode(":",$elem2->getSingleAttribute("urnRegValue"));
	return count($val1)>count($val2);
}

$lm=new LdapManager($LDAP_SERVER_NAME,$LDAP_SERVER_PORT);
$lm->setOption(LDAP_OPT_PROTOCOL_VERSION,3);
$lm->connectLdap($LDAP_USER,$LDAP_PASS);

$success=false;

if (array_key_exists('urn',$_REQUEST)) {
	$urnvalue=rawurldecode($_REQUEST['urn']);
	$format='human';
    if (array_key_exists('format',$_REQUEST)) {
    	$format=$_REQUEST['format'];
    }
    $urn=getURNEntry($lm,$urnvalue);
    if (!is_string($urn)) {
    	if (strcmp($format,"machine")==0) {
			header('Content-type: text/xml');
			echo "<Response>";
			echo echoURNDescription($urn);
			echo "</Response>";
    	}
    	else {
    		$xml = DOMDocument::loadXML(echoURNDescription($urn));
			$xsl = new DomDocument;
			$xsl->load('template.xslt');
			
			$proc = new XSLTProcessor;
			$proc->importStyleSheet($xsl);
			$proc->setParameter('','uri',$_SERVER['REQUEST_URI']);
			$proc->setParameter('','urixml',$_SERVER['REQUEST_URI']."&format=machine");
			echo($proc->transformToXML($xml));
		}
    }
    else {
	echo "<p>URN <strong>".$urnvalue."</strong> not found</p>";
    }
}
else {
	include_once("form.html");
}

?>
